package chapter4_dateandtime;

import java.time.Clock;

/**
 * Beispielprogramm zur Demonstration der neuen Klasse Clock.
 * 
 * @author Michael Inden
 * 
 * Copyright 2014 by Michael Inden 
 */
public class ClockExample 
{
	public static void main(final String[] args) 
	{
		// Basis: UTC 
		final Clock clock = Clock.systemUTC();
		System.out.println(clock);
		printClockMillis(clock);
	
		// Basis: Default-Zeitzone  
		final Clock clock2 = Clock.systemDefaultZone();
		System.out.println(clock2);	
		printClockMillis(clock2);
	}
	
	private static void printClockMillis(final Clock clock) 
	{
		final long currentTime = clock.millis();
		System.out.println(currentTime);
	}
}