package chapter4_dateandtime;

import java.time.Instant;
import java.time.LocalDateTime;
import java.time.ZoneId;
import java.time.ZonedDateTime;
import java.util.Date;
import java.util.GregorianCalendar;

/**
 * Beispielprogramm zur Demonstration der Interaktion mit dem alten Date-/Calendar-API.
 * 
 * @author Michael Inden
 * 
 * Copyright 2014 by Michael Inden 
 */
public class LegacyExample 
{
	public static void main(final String[] args) 
	{
		// Berechnungen basierend auf Date
		final Date now = new Date();
		final Instant nowAsInstant = now.toInstant();
	
		final ZoneId myZone = ZoneId.systemDefault();
		final LocalDateTime localDateTime = LocalDateTime.ofInstant(nowAsInstant, myZone);
		
		final ZoneId zoneCalifornia = ZoneId.of("America/Los_Angeles");
		final ZonedDateTime zonedDateTime = ZonedDateTime.ofInstant(nowAsInstant, zoneCalifornia);
		
		System.out.println("LocalDateTime: " + localDateTime);
		System.out.println("ZonedDateTime: " + zonedDateTime);
	
		// Berechnungen basierend auf Calender
		final GregorianCalendar nowAsCalendar = new GregorianCalendar();
		final ZonedDateTime nowAszonedDateTime = nowAsCalendar.toZonedDateTime();
		
		final Instant instant = nowAszonedDateTime.toInstant();
		System.out.println("Instant:       " + instant);
	}
}