package chapter4_dateandtime;

import java.time.Month;
import java.time.MonthDay;
import java.time.Year;
import java.time.YearMonth;

/**
 * Beispielprogramm zur Demonstration der neuen Klassen Year und YearMonth usw.
 * 
 * @author Michael Inden
 * 
 * Copyright 2014 by Michael Inden 
 */
public class YearAndMoreExample
{
    public static void main(final String[] args)
    {
        // YearMonth: Demonstration jeweils mit und ohne Konstanten  
        final YearMonth yearMonth = YearMonth.of(2014, 2);
        final YearMonth february2014 = YearMonth.of(2014, Month.FEBRUARY);

        // MonthDay: Achtung, amerikanische Reihenfolge Monat, Tag  
        final int dayOfBirthday = 7;
        final MonthDay monthDay1 = MonthDay.of(2, dayOfBirthday);
        final MonthDay monthDay2 = MonthDay.of(Month.FEBRUARY, dayOfBirthday);

        // Year 
        final Year year = Year.of(2012);

        System.out.println("YearMonth: " + february2014);
        System.out.println("MonthDay:  " + monthDay2);
        System.out.println("Year:      " + year + " / isLeap? " + year.isLeap());
    }
}