package chapter6_misc.comparator;

import java.util.ArrayList;
import java.util.Comparator;
import java.util.List;
import java.util.function.Function;

import chapter3_streams.Gender;
import chapter3_streams.Person;

/**
 * Beispielprogramm zeigt die Definition von verschiedenen Komparatoren unter anderem zur natrlichen Ordnung und der dazu inversen Ordnung.
 * 
 * @author Michael Inden
 * 
 * Copyright 2014 by Michael Inden 
 */
public class WrongNullSafeComparatorsExample 
{
	public static void main(final String[] args) 
	{
		Function<Person, String> keyExtractor = Person::getFavoriteColor;
		Comparator<Person> byFavoriteColor = Comparator.comparing(keyExtractor);

		// Spezialfall: Behandlung von null
		Comparator<Person> nullSafebyFavoriteColor = Comparator.nullsFirst(byFavoriteColor);

		// Comparator<Person> byFavoriteColor2 = Comparator.nullsFirst(Person::getFavoriteColor);
		
		final List<Person> persons = createDemoData();
		
		persons.sort(nullSafebyFavoriteColor);
	}
	
	private static List<Person> createDemoData() {
		final List<Person> persons = new ArrayList<>();
		persons.add(new Person("Michael", 43));
		persons.add(new Person("Barbara", 41, Gender.FEMALE));
		persons.add(new Person("Lili", 34, Gender.FEMALE));
		persons.add(new Person("Mona Lisa", 17, Gender.FEMALE));
		persons.add(new Person("Tom", 8));
		persons.add(new Person("Bjrn", 7));
		return persons;
	}
}